#ifndef AIM_H
#define AIM_H

#include <inttypes.h>
#include "global.h"

#define AIM_CONST 0xA3

/* aimRawBuffer[] index: */
#define AIM_DISPLAY_TOP  0
#define AIM_DISPLAY_BOTTOM  1
#define AIM_DISPLAY_PEAKTOP 2
#define AIM_DISPLAY_PEAKBOTTOM  3

/*
typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
*/

enum AIMState { AIM_UNKNOWN=0, AIM_START = 2, AIM_DATA_LOW =3, AIM_SUM = 4, AIM_OK = 5, AIM_ERROR=6 };

struct AIMData_t
{
    uint8_t channel;
    uint8_t value_h;
    uint8_t value_l;
    uint8_t sum;
};

struct AIMControl_t
{
    uint8_t state;
    uint8_t prevByte;
};

struct AIMResult_t
{
	uint16_t aimCount;	/* just for debugging */
	/* uint16_t aimFinalResult[2]; final result, just for debugging */
	uint16_t aimRawBuffer[4]; /*  top, bottom could be filtered (now LAST received value)
		and top_peak, bottom_peak */
};

uint8_t aim_feed( uint8_t c );
int16_t getAimDisplayValue(uint8_t pos);
uint8_t aim_unpack( uint8_t idx, uint8_t packed );

extern struct AIMData_t aimData;
extern struct AIMControl_t aimControl;
extern struct AIMResult_t aimResult;
#endif
